Add stable/2402 branch and remove stable/2306 branch to docker executor image scripts
[ci-management.git] / docker / scripts / dbld_vpp_install_packages.sh
1 #! /bin/bash
2
3 # Copyright (c) 2021 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -euxo pipefail
17
18 export CIMAN_DOCKER_SCRIPTS=${CIMAN_DOCKER_SCRIPTS:-"$(dirname $BASH_SOURCE)"}
19 . "$CIMAN_DOCKER_SCRIPTS/lib_vpp.sh"
20 . "$CIMAN_DOCKER_SCRIPTS/lib_apt.sh"
21
22 must_be_run_in_docker_build
23
24 echo_log
25 if ! vpp_supported_executor_class "$FDIOTOOLS_EXECUTOR_CLASS" ; then
26     echo_log "VPP is not supported on executor class '$FDIOTOOLS_EXECUTOR_CLASS'. Skipping $(basename $0)..."
27     exit 0
28 else
29     echo_log "Starting  $(basename $0)"
30 fi
31
32 do_git_config vpp
33 for branch in ${VPP_BRANCHES[$OS_NAME]} ; do
34     do_git_branch "$branch"
35
36     # Install OS packages
37     make_vpp "install-dep" "$branch"
38
39     # Download, build, and cache external deps packages
40     make_vpp "install-ext-deps" "$branch"
41     vpp_ext_dir="$DOCKER_VPP_DIR/build/external"
42     rsync -ac $vpp_ext_dir/downloads/. $DOCKER_DOWNLOADS_DIR || true
43     if which apt >/dev/null ; then
44         vpp_ext_deps_pkg=$vpp_ext_dir/$(dpkg -l vpp-ext-deps 2>/dev/null | mawk '/vpp-ext-deps/{print $2"_"$3"_"$4".deb"}')
45     else
46         echo "ERROR: Package Manager not installed!"
47         exit 1
48     fi
49     if [ -f "$vpp_ext_deps_pkg" ] ; then
50         cp -f $vpp_ext_deps_pkg $DOCKER_DOWNLOADS_DIR
51     else
52         echo "ERROR: Missing VPP external deps package: '$vpp_ext_deps_pkg'"
53         exit 1
54     fi
55     # TODO: remove this after all supported VPP branches have removed
56     # python3-virtualenv & virtualenv from install-deps which are no longer
57     # used in vpp repo.  These packages can mess up csit virtualenv
58     # installation which uses pip3
59     sudo apt remove -y --purge --autoremove python3-virtualenv virtualenv || true
60
61     # Install/cache python packages
62     make_vpp_test "test-dep" "$branch"
63     if [ "$OS_ID" = "ubuntu" ] ; then
64         make_vpp test-wipe "$branch"
65     fi
66     # Clean up virtual environment
67     git checkout -q -- .
68     git clean -qfdx
69
70     # Dump packages installed
71     case "$DOCKERFILE_FROM" in
72         *ubuntu*)
73             dump_apt_package_list "$branch" ;;
74         *debian*)
75             dump_apt_package_list "$branch" ;;
76     esac
77 done
78
79 echo_log -e "Completed $(basename $0)!\n\n=========="